



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>js重点--原型链</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">js重点--原型链</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-29 19:11:42 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>通过<strong>将一个构造函数的原型对象指向父类的实例</strong>，就可以调用父类中的实例属性及父类的原型对象属性，实现继承。</p>
<div>
<pre class="prettyprint linenums">function animals(){<br />
    this.type = "animals";<br />
    this.emotion = ["喜","怒","哀","乐"];<br />
}<br />
animals.prototype.eat = function(){<br />
    console.log("吃吃吃");<br />
}<br />
animals.prototype.drink = function(){<br />
    console.log("喝喝喝");<br />
}<br />
function dog(){<br />
    this.type = "dog";<br />
    // animals.call(this);<br />
}<br />
dog.prototype = new animals();<br />
// console.log(dog.prototype.constructor);<br />
// dog.prototype.constructor = dog;<br />
// console.log(dog.prototype.constructor);

var d = new dog();<br />
console.log(d.emotion);<br />
d.emotion.push("愁");<br />
console.log(d.emotion);<br />
console.log(d);<br />
d.eat();

var d2 = new dog();<br />
console.log(d2.emotion);<br />
console.log(d2);</pre>
</div>
<p>dog.prototype = new animals();可以调用animals中的实例属性及animals中的原型对象属性，</p>
<p>var d = new dog();创建了dog的一个实例，可以调用dog中的实例属性，然后调用dog的原型对象属性，因为他的原型对象指向animals的一个实例，此时会调用animals中的实例属性，最后调用animals中的原型对象属性。</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1098640/201901/1098640-20190128155341611-1781715236.png" /></p>
<p>结果如上，d,d2实例中的内容均为构造函数dog中的属性内容，当在一个实例中改变emotion的内容时，父类中的emotion也会改变，下一个实例调用时，内容为改变之后的。</p>
<p><strong>在实例中改变父类中属性内容时，父类中的属性不会被改变；除非改变的是引用类型的内容。</strong></p>
<p>若是在构造函数dog中加上animals.call(this);，即借用构造函数调用，</p>
<p><strong><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1098640/201901/1098640-20190128160107623-1574897642.png" /></strong></p>
<p>结果如上，d,d2中的内容均为animals构造函数中的属性内容，因为在dog构造函数中调用了animals构造函数，会拷贝animals函数中的属性内容，但animals原型对象中的属性不会读写拷贝，若是没有dog.prototype = new animals();这一句，当d.eat();执行时将会报错，无法读取animals原型对象中的属性。</p>
<p>当在实例中改变emotion值时，其他实例中该值未被改变，因为在各自的实例中都拷贝了一份animals构造函数中的属性。</p>
<p><strong>若是想要既实现在实例中改变值，但父类中值不改变，还能实现代码复用的简便性，可以将animals.call(this);与dog.prototype = new animals();结合起来使用。</strong></p>
<p>参考博客：<a href="https://www.cnblogs.com/sarahwang/p/9098044.html" rel="external nofollow noreferrer">https://www.cnblogs.com/sarahwang/p/9098044.html</a></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/m8zyl339.html">js表单动态添加数据并提交</a>
		</li>
						<li><a href="https://www.batexi.com/a/495verzq.html">uniq  重复行统计</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8eldmjq.html">&lbrack;驱动&rsqb;内核添加USB转串口驱动支持</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qwgrxk8.html">&period;net中自定义过滤器对Response内容进行处理</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9jyo6g9.html">Android SnapHelper</a>
		</li>
						<li><a href="https://www.batexi.com/a/8okn2wl9.html">PHP建站通过服务器架构及实战的方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qydv2xxq.html">配置DNS域名解析服务器</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gmg32e9.html">Loadrunner模拟Json请求</a>
		</li>
						<li><a href="https://www.batexi.com/a/95x7jrv8.html">Java汉字排序&lpar;1&rpar;排序前要了解的知识（数组和list的排序接口）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwd46el8.html">认识CoreData-高级用法</a>
		</li>
						<li><a href="https://www.batexi.com/a/90v1nen8.html">spring Cache注解</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxn37lj8.html">使用shiro安全框架上传文件时用HttpSession获取ServletContext为null问题解决方法。</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j037dlq.html">自己写的简单的jQuery分页控件</a>
		</li>
						<li><a href="https://www.batexi.com/a/90mvj448.html">Spring Boot Mongodb</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4zpde39.html">UIAlerView、UIActionSheet 和UIAlertViewController&lpar;点击注销确认按钮实现）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ey0zwm9.html">laravel 报错 mcrypt&lowbar;decrypt&lpar;&rpar;&colon; Key of size 11 not supported by this algorithm&period; Only keys of sizes 16&comma; 24 or 32 supported</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gevdo48.html">PS 图像调整算法&mdash;&mdash;反相</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eydx7j9.html">DirectX11 With Windows SDK--16 流输出阶段</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o1105xq.html">springboot情操陶冶-&commat;Conditional和&commat;AutoConfigureAfter注解解析</a>
		</li>
						<li><a href="https://www.batexi.com/a/qll711kq.html">odoo 学习</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8oje1llq.html">java集合介绍（List，Set，Map）</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gewjx48.html">Java中单例模式的几种实现</a>
			</li>
						<li><a href="https://www.batexi.com/a/qy1k2vmq.html">Java基础之入门</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxkvloe8.html">Linux学习历程&mdash;&mdash;Centos 7 chmod命令</a>
			</li>
						<li><a href="https://www.batexi.com/a/96pem5y8.html">Linux（一）&mdash;&mdash; Unix&amp;amp&semi;Linux 历史</a>
			</li>
						<li><a href="https://www.batexi.com/a/950omr68.html">金蝶K3外购入库单单价取数规则调整</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kp72n69.html">bound&plus;vlan</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlj4vv09.html">iic接口介绍</a>
			</li>
						<li><a href="https://www.batexi.com/a/8eyv33m9.html">pycharm 安装dilb模块</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnjogkx8.html">JAVA基础知识回顾（面试资料）</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
